

   MEMBER('ocxdemo.clw')                              ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('OCXDE002.INC'),ONCE        !Local module procedure declarations
CalendarOCXOLEEventHandler PROCEDURE(*SHORT ref,SIGNED OLEControlFEQ,LONG OLEEvent),LONG
                     END


CalendarOCX PROCEDURE                                 !Generated from procedure template - Window

window               WINDOW('Select A Date...'),AT(,,260,204),GRAY,DOUBLE
                       PROMPT('Date'),AT(16,4),USE(?GLO:Date:Prompt)
                       STRING(@d01b),AT(36,4),USE(GLO:Date),RIGHT(1)
                       OLE,AT(12,16,203,142),USE(?OLE),CREATE('MSCAL.Calendar.7'),COMPATIBILITY(020H),AUTOSIZE
                       END
                       BUTTON('Set Today'),AT(68,164,45,14),USE(?TodayButton)
                       BUTTON('Set to 1st Of Month'),AT(116,164,,14),USE(?FirstMonthButton)
                       BUTTON('Properties'),AT(196,164,45,14),USE(?PropertiesButton)
                       BUTTON('Close'),AT(104,184,45,14),USE(?Close)
                       BUTTON('About'),AT(20,164,45,14),USE(?AboutButton)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Open                   PROCEDURE(),DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('CalendarOCX')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?GLO:Date:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  OPEN(window)
  SELF.Opened=True
  OCXRegisterEventProc(?OLE,CalendarOCXOLEEventHandler)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Open PROCEDURE

  CODE
  ! Store the FEQ into the global variable
  GLO:Container = ?OLE
  PARENT.Open


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?OLE
      GLO:Date = Deformat(?OLE{'Value'},@D02)
    OF ?PropertiesButton
      ?OLE{PROP:DoVerb} = 0 ! Open the control's properties
    OF ?AboutButton
      ?OLE{'AboutBox'}  ! Call the control's about box
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?TodayButton
      ThisWindow.Update
      ?OLE{'Value'} = Format(Today(),@D01)
    OF ?FirstMonthButton
      ThisWindow.Update
      ! Set control to beginning of the month
      ?OLE{'Value'} = Month(today()) & '/1/' & Sub(Year(Today()),3,2)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!---------------------------------------------------
CalendarOCXOLEEventHandler FUNCTION(*SHORT ref,SIGNED OLEControlFEQ,LONG OLEEvent)
  CODE
  Post(Event:Accepted, GLO:Container)
  RETURN(True)
